//+------------------------------------------------------------------+
//|                                                 BucCM_Master.mq4 |
//|                                    Copyright  2007, Petr Kouril |
//|                                           http://www.jaktrade.cz |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Petr Kouril"
#property link      "http://www.bucafon.cz"

#define           GLOBAL_PREF             "BucCMST_"       // toto musi  stejne jako pouziva slave!!!
#define           OBJECT_PREF             "BucServerST_"   // Zobrazeni hdnot men
#define           CHAR_HEIGHT             7
#define           OBJECT_XDIFF            45
#define           REVISION                "1.4"

#property indicator_separate_window
#property indicator_minimum  0
#property indicator_maximum  100


#property indicator_buffers 8
#property indicator_color1 Red         // USD
#property indicator_color2 Black       // EUR
#property indicator_color3 Blue        // GBP
#property indicator_color4 DarkGreen   // CHF
#property indicator_color5 Indigo      // CAD
#property indicator_color6 Orange      // AUD
#property indicator_color7 Magenta     // JPY
#property indicator_color8 Lime        // NZD
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 1
#property indicator_width6 1
#property indicator_width7 1
#property indicator_width8 1


extern int        StochKPeriod            = 14;
extern int        StochDPeriod            = 3;
extern int        StochSloving            = 4;
extern int        StochMethod             = MODE_EMA;
extern int        TimeFrame               = 0;
extern int        ShowHistoryBars         = 100;
extern bool       SetGlobalVariable       = true;
extern string     DataFileName            = "";
extern int        FileWriteTime           = 2;

double            TS_USD, TS_EUR, TS_GBP, TS_CHF, TS_CAD, TS_AUD, TS_JPY, TS_NZD;
int               FileHandle;
double            OK_USD, OK_EUR, OK_GBP, OK_CHF, OK_CAD, OK_AUD, OK_JPY, OK_NZD;
bool              PairOK[29];

//---- buffers
double            BuffUSD[], BuffEUR[], BuffGBP[], BuffCHF[], BuffCAD[], BuffAUD[], BuffJPY[], BuffNZD[];

int init()
{
	IndicatorBuffers(8);

   SetIndexStyle (0, DRAW_LINE);
   SetIndexBuffer(0, BuffUSD);
   SetIndexLabel (0, "USD");

   SetIndexStyle (1, DRAW_LINE);
   SetIndexBuffer(1, BuffEUR);
   SetIndexLabel (1, "EUR");

   SetIndexStyle (2, DRAW_LINE);
   SetIndexBuffer(2, BuffGBP);
   SetIndexLabel (2, "GBP");

   SetIndexStyle (3, DRAW_LINE);
   SetIndexBuffer(3, BuffCHF);
   SetIndexLabel (3, "CHF");

   SetIndexStyle (4, DRAW_LINE);
   SetIndexBuffer(4, BuffCAD);
   SetIndexLabel (4, "CAD");

   SetIndexStyle (5, DRAW_LINE);
   SetIndexBuffer(5, BuffAUD);
   SetIndexLabel (5, "AUD");

   SetIndexStyle (6, DRAW_LINE);
   SetIndexBuffer(6, BuffJPY);
   SetIndexLabel (6, "JPY");

   SetIndexStyle (7, DRAW_LINE);
   SetIndexBuffer(7, BuffNZD);
   SetIndexLabel (7, "NZD");
   
   IndicatorShortName(GetIndicatorShortName());

   if (DataFileName != "")
   {
      FileHandle = FileOpen(DataFileName, FILE_CSV | FILE_READ | FILE_WRITE);
      if (FileSize(FileHandle) == 0 ) FileWrite(FileHandle, "cas serveru;cas serveru;cas pocitace;USD;EUR;GBP;CHF;CAD;AUD;JPY;NZD");
      FileSeek(FileHandle, 0, SEEK_END);
   }
   else
      FileHandle = -1;

   CheckValidPairs();
   
   return(0);
}

int deinit()
{
   DeleteAllObjects();
   
   if (FileHandle != -1)
      FileClose(FileHandle);
      
   return(0);
}

void CheckValidPairs()
{
   Print("Check valid pairs");
   OK_USD = 0;
   OK_EUR = 0;
   OK_GBP = 0;
   OK_CHF = 0;
   OK_CAD = 0;
   OK_AUD = 0;
   OK_JPY = 0;
   OK_NZD = 0;

   for (int i = 1; i <= 28; i++)
   {
      if (iLow(GetCurrencyNameByIndex(i), 1440, 0) > 0.00000001)
//      if (GetCurrencyNameByIndex(i) == "EURCHF")
      {
         PairOK[i] = true;
         
         if ((StringSubstr(GetCurrencyNameByIndex(i), 0, 3) == "USD") || (StringSubstr(GetCurrencyNameByIndex(i), 3, 3) == "USD")) OK_USD = OK_USD + 1;
         if ((StringSubstr(GetCurrencyNameByIndex(i), 0, 3) == "EUR") || (StringSubstr(GetCurrencyNameByIndex(i), 3, 3) == "EUR")) OK_EUR = OK_EUR + 1;
         if ((StringSubstr(GetCurrencyNameByIndex(i), 0, 3) == "GBP") || (StringSubstr(GetCurrencyNameByIndex(i), 3, 3) == "GBP")) OK_GBP = OK_GBP + 1;
         if ((StringSubstr(GetCurrencyNameByIndex(i), 0, 3) == "CHF") || (StringSubstr(GetCurrencyNameByIndex(i), 3, 3) == "CHF")) OK_CHF = OK_CHF + 1;
         if ((StringSubstr(GetCurrencyNameByIndex(i), 0, 3) == "CAD") || (StringSubstr(GetCurrencyNameByIndex(i), 3, 3) == "CAD")) OK_CAD = OK_CAD + 1;
         if ((StringSubstr(GetCurrencyNameByIndex(i), 0, 3) == "AUD") || (StringSubstr(GetCurrencyNameByIndex(i), 3, 3) == "AUD")) OK_AUD = OK_AUD + 1;
         if ((StringSubstr(GetCurrencyNameByIndex(i), 0, 3) == "JPY") || (StringSubstr(GetCurrencyNameByIndex(i), 3, 3) == "JPY")) OK_JPY = OK_JPY + 1;
         if ((StringSubstr(GetCurrencyNameByIndex(i), 0, 3) == "NZD") || (StringSubstr(GetCurrencyNameByIndex(i), 3, 3) == "NZD")) OK_NZD = OK_NZD + 1;
      }
      else
      {
         PairOK[i] = false;
         Print(GetCurrencyNameByIndex(i), " not found");
      }
   }
   Print("NZD found: ", OK_NZD, "x");
   Print("JPY found: ", OK_JPY, "x");
   Print("AUD found: ", OK_AUD, "x");
   Print("CAD found: ", OK_CAD, "x");
   Print("CHF found: ", OK_CHF, "x");
   Print("GBP found: ", OK_GBP, "x");
   Print("EUR found: ", OK_EUR, "x");
   Print("USD found: ", OK_USD, "x");
}

void DeleteAllObjects()
{
   int i, ObjTotal = ObjectsTotal();
   string Str;
   
   for (i = ObjTotal-1; i >= 0; i--)
   {
      Str = StringSubstr(ObjectName(i), 0, StringLen(OBJECT_PREF));
      if (Str == OBJECT_PREF)
         ObjectDelete(ObjectName(i));
   }
}

string GetIndicatorShortName()
{
   return ("BucCM_Master_Stochastic " + REVISION + " (" + StochKPeriod + "," + StochDPeriod + "," + StochSloving + "," + GetPeriodString() + ")");
}

double GetGlobalVariableNum()
{
   return (StochKPeriod + StochDPeriod * StochSloving * GetPeriod());
}

static int    PrevTime, PrevBar,CurrBar;     //posledni cas otevreni souboru s historii CurrencyMeteru
void WriteData()
{
   if (FileHandle == -1) return;
   CurrBar = iTime(NULL, 1, 0);
   if (((PrevTime + FileWriteTime) <= TimeCurrent()) || (CurrBar != PrevBar))
   {
      FileWrite(FileHandle, TimeToStr(TimeCurrent(), TIME_DATE | TIME_SECONDS), TimeCurrent(), TimeToStr(TimeLocal(), TIME_DATE | TIME_SECONDS),
                TS_USD, TS_EUR, TS_GBP, TS_CHF, TS_CAD, TS_AUD, TS_JPY, TS_NZD);
      FileFlush(FileHandle);
      PrevTime = TimeCurrent();
      PrevBar  = CurrBar;
   }
}

int start()
{
	int counted_bars = IndicatorCounted();
	int i;
	
	//---- 
	  if(counted_bars < 0) 
	    { 
	      Print("Indicator Error (Counted bars < 0)!"); 
	      return(-1); 
	    }
  //----
	 
	for(i=Bars-counted_bars; i>=0; i--)
  {
   if (i>ShowHistoryBars) i=ShowHistoryBars;
	
   CurrencyMeter(i);   
   
   
      
   BuffUSD[i] = TS_USD;
   BuffEUR[i] = TS_EUR;
   BuffGBP[i] = TS_GBP;
   BuffCHF[i] = TS_CHF;
   BuffCAD[i] = TS_CAD;
   BuffAUD[i] = TS_AUD;
   BuffJPY[i] = TS_JPY;
   BuffNZD[i] = TS_NZD;
  }
  
   if (SetGlobalVariable)
   {
      GlobalVariableSet(GLOBAL_PREF + DoubleToStr(GetGlobalVariableNum(), 0) + "USD", TS_USD);
      GlobalVariableSet(GLOBAL_PREF + DoubleToStr(GetGlobalVariableNum(), 0) + "EUR", TS_EUR);
      GlobalVariableSet(GLOBAL_PREF + DoubleToStr(GetGlobalVariableNum(), 0) + "GBP", TS_GBP);
      GlobalVariableSet(GLOBAL_PREF + DoubleToStr(GetGlobalVariableNum(), 0) + "CHF", TS_CHF);
      GlobalVariableSet(GLOBAL_PREF + DoubleToStr(GetGlobalVariableNum(), 0) + "CAD", TS_CAD);
      GlobalVariableSet(GLOBAL_PREF + DoubleToStr(GetGlobalVariableNum(), 0) + "AUD", TS_AUD);
      GlobalVariableSet(GLOBAL_PREF + DoubleToStr(GetGlobalVariableNum(), 0) + "JPY", TS_JPY);
      GlobalVariableSet(GLOBAL_PREF + DoubleToStr(GetGlobalVariableNum(), 0) + "NZD", TS_NZD);
      
      GlobalVariableSet(GLOBAL_PREF + DoubleToStr(GetGlobalVariableNum(), 0) + "Hour",     Hour());
      GlobalVariableSet(GLOBAL_PREF + DoubleToStr(GetGlobalVariableNum(), 0) + "Minute",   Minute());
      GlobalVariableSet(GLOBAL_PREF + DoubleToStr(GetGlobalVariableNum(), 0) + "Second",   Seconds());
      GlobalVariableSet(GLOBAL_PREF + DoubleToStr(GetGlobalVariableNum(), 0) + "DateTime", TimeCurrent());
   }

   ShowTextObject(OBJECT_PREF + DoubleToStr(GetGlobalVariableNum(), 0)  + "USD",  1 + 0 * OBJECT_XDIFF, 1, "USD " + DoubleToStr(TS_USD, 0), indicator_color1);
   ShowTextObject(OBJECT_PREF + DoubleToStr(GetGlobalVariableNum(), 0)  + "EUR",  1 + 1 * OBJECT_XDIFF, 1, "EUR " + DoubleToStr(TS_EUR, 0), indicator_color2);
   ShowTextObject(OBJECT_PREF + DoubleToStr(GetGlobalVariableNum(), 0)  + "GBP",  1 + 2 * OBJECT_XDIFF, 1, "GBP " + DoubleToStr(TS_GBP, 0), indicator_color3);
   ShowTextObject(OBJECT_PREF + DoubleToStr(GetGlobalVariableNum(), 0)  + "CHF",  1 + 3 * OBJECT_XDIFF, 1, "CHF " + DoubleToStr(TS_CHF, 0), indicator_color4);
   ShowTextObject(OBJECT_PREF + DoubleToStr(GetGlobalVariableNum(), 0)  + "CAD",  1 + 4 * OBJECT_XDIFF, 1, "CAD " + DoubleToStr(TS_CAD, 0), indicator_color5);
   ShowTextObject(OBJECT_PREF + DoubleToStr(GetGlobalVariableNum(), 0)  + "AUD",  1 + 5 * OBJECT_XDIFF, 1, "AUD " + DoubleToStr(TS_AUD, 0), indicator_color6);
   ShowTextObject(OBJECT_PREF + DoubleToStr(GetGlobalVariableNum(), 0)  + "JPY",  1 + 6 * OBJECT_XDIFF, 1, "JPY " + DoubleToStr(TS_JPY, 0), indicator_color7);
   ShowTextObject(OBJECT_PREF + DoubleToStr(GetGlobalVariableNum(), 0)  + "NZD",  1 + 7 * OBJECT_XDIFF, 1, "NZD " + DoubleToStr(TS_NZD, 0), indicator_color8);

   WriteData();
}

void ShowTextObject(string ObjName, int XPos, int YPos, string TextToShow, int TextColor)
{
   if (ObjectFind(ObjName) == -1)
   {
      ObjectCreate (ObjName, OBJ_LABEL, WindowFind(GetIndicatorShortName()), 0, 0);
      ObjectSet    (ObjName, OBJPROP_CORNER, 2);
      ObjectSet    (ObjName, OBJPROP_XDISTANCE, XPos);
      ObjectSet    (ObjName, OBJPROP_YDISTANCE, YPos);
   }
   ObjectSetText(ObjName, TextToShow, CHAR_HEIGHT, "Arial Bold", TextColor);
}

string GetCurrencyNameByIndex(int Index)
{
   switch (Index)
   {
   case 1: return  ("EURUSD");
   case 2: return  ("GBPUSD");
   case 3: return  ("AUDUSD");
   case 4: return  ("USDJPY");
   case 5: return  ("USDCHF");
   case 6: return  ("USDCAD");
   case 7: return  ("EURJPY");
   case 8: return  ("EURGBP");
   case 9: return  ("EURCHF");
   case 10: return ("EURAUD");
   case 11: return ("GBPJPY");
   case 12: return ("GBPCHF");
   case 13: return ("EURCAD");
   case 14: return ("CHFJPY");
   case 15: return ("CADJPY");
   case 16: return ("CADCHF");
   case 17: return ("AUDCHF");
   case 18: return ("AUDCAD");
   case 19: return ("AUDJPY");
   case 20: return ("NZDUSD");
   case 21: return ("NZDCAD");
   case 22: return ("NZDCHF");
   case 23: return ("NZDJPY");
   case 24: return ("NZDGBP");
   case 25: return ("EURNZD");
   case 26: return ("GBPCAD");
   case 27: return ("GBPAUD");
   case 28: return ("AUDNZD");
   default: return ("");
   }
}

double GetStochastic(int CurIndex, int shift)
{
   if (!PairOK[CurIndex]) return (0);
   return (iStochastic(GetCurrencyNameByIndex(CurIndex), TimeFrame, StochKPeriod, StochDPeriod, StochSloving, StochMethod, 0, MODE_MAIN, shift));
}

void CurrencyMeter(int shift)
{
   double bid_ratio[29];
   for (int i = 0; i <= 28; i++)
   {
      bid_ratio[i] = GetStochastic(i, shift);      
   }
   
   double RS13[29];
   double RS15[29];
   for (i = 1; i <= 28; i++)
   {
      if (PairOK[i])
      {      
         RS13[i] = bid_ratio[i];
         RS15[i] = 100 - RS13[i];
      }
      else
      {
         RS13[i] = 0;
         RS15[i] = 0;
      }
   }
   
   TS_USD = NormalizeDouble((RS13[4] +RS13[5] +RS13[6] +RS15[1] +RS15[2] +RS15[3] +RS15[20]) / OK_USD, 0);
   TS_EUR = NormalizeDouble((RS13[1] +RS13[7] +RS13[8] +RS13[9] +RS13[10]+RS13[13]+RS13[25]) / OK_EUR, 0);
   TS_GBP = NormalizeDouble((RS13[2] +RS13[11]+RS13[12]+RS13[26]+RS13[27]+RS15[8] +RS15[24]) / OK_GBP, 0);
   TS_CHF = NormalizeDouble((RS13[14]+RS15[5] +RS15[9] +RS15[12]+RS15[16]+RS15[17]+RS15[22]) / OK_CHF, 0);
   TS_CAD = NormalizeDouble((RS13[15]+RS13[16]+RS15[6] +RS15[13]+RS15[18]+RS15[21]+RS15[26]) / OK_CAD, 0);
   TS_AUD = NormalizeDouble((RS13[3] +RS13[17]+RS13[18]+RS13[19]+RS13[28]+RS15[10]+RS15[27]) / OK_AUD, 0);
   TS_JPY = NormalizeDouble((RS15[4] +RS15[7] +RS15[11]+RS15[14]+RS15[15]+RS15[19]+RS15[23]) / OK_JPY, 0);
   TS_NZD = NormalizeDouble((RS13[20]+RS13[21]+RS13[22]+RS13[23]+RS13[24]+RS15[25]+RS15[28]) / OK_NZD, 0);

}   

int GetPeriod()
{
	int CurrentPeriod = TimeFrame;
	if (TimeFrame == 0)
		CurrentPeriod = Period();
   return (CurrentPeriod);
}

string GetPeriodString()
{
	switch (GetPeriod())
	{
		case PERIOD_M1:  return ("M1");
		case PERIOD_M5:  return ("M5");
		case PERIOD_M15: return ("M15");
		case PERIOD_M30: return ("M30");
		case PERIOD_H1:  return ("H1");
		case PERIOD_H4:  return ("H4");
		case PERIOD_D1:  return ("D1");
		case PERIOD_W1:  return ("W1");
		default:			  return ("???");
	}
}

